unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  ExtCtrls, fppdfobjects, fppdfparser, DOM,  XMLWrite;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    FXMLDoc: TXMLDocument;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses Xml.Builder;

{ TForm1 }

procedure TForm1.Button2Click(Sender: TObject);
var
  Doc: TXMLDocument;                                         // Variable für das Dokument
  CrossIndustryInvoice,                                      // Wurzelknoten
  ExchangedDocument,                                         // Rechnungskopf
  rsm_ID,                                                    // BT-1 Rechnungsnummer
  TypeCode,                                                  //
  IssueDateTime,
  DateTimeString,
  IncludedNote,
  Content,
  SupplyChainTradeTransaction,
  IncludedSupplyChainTradeLineItem,
  AssociatedDocumentLineDocument,
  LineID,
  SpecifiedTradeProduct,
  ram_Name,
  SpecifiedLineTradeAgreement,
  NetPriceProductTradePrice,
  ChargeAmount,
  Textelement: TDOMNode;                   // Variable für die Elemente (Knoten)
begin
  try
    // Erzeuge ein Dokument
    Doc := TXMLDocument.Create;

    // Wurzelknoten rsm:CrossIndustryInvoice
    CrossIndustryInvoice := Doc.CreateElement('rsm:CrossIndustryInvoice');
    TDOMElement(CrossIndustryInvoice).SetAttribute('xmlns:udt', 'urn:un:unece:uncefact:data:standard:UnqualifiedDataType:100');
    TDOMElement(CrossIndustryInvoice).SetAttribute('xmlns:xs', 'http://www.w3.org/2001/XMLSchema');
    TDOMElement(CrossIndustryInvoice).SetAttribute('xmlns:ram', 'urn:un:unece:uncefact:data:standard:ReusableAggregateBusinessInformationEntity:100');
    TDOMElement(CrossIndustryInvoice).SetAttribute('xmlns:qdt', 'urn:un:unece:uncefact:data:standard:QualifiedDataType:100');
    TDOMElement(CrossIndustryInvoice).SetAttribute('xmlns:rsm', 'urn:un:unece:uncefact:data:standard:CrossIndustryInvoice:100');
    Doc.Appendchild(CrossIndustryInvoice);
    // Element rsm:ExchangedDocument
    ExchangedDocument := Doc.CreateElement('rsm:ExchangedDocument');
    CrossIndustryInvoice.Appendchild(ExchangedDocument);

    // Element rsm:ID
    rsm_ID := Doc.CreateElement('ram:ID');                      // (BT-1) Rechnungsnummer
    Textelement := Doc.CreateTextNode('1/KB/24');
    rsm_ID.Appendchild(Textelement);
    ExchangedDocument.AppendChild(rsm_ID);

    // Element ram:TypeCode
    TypeCode := Doc.CreateElement('ram:TypeCode');
    Textelement := Doc.CreateTextNode('380');
    TypeCode.Appendchild(Textelement);
    ExchangedDocument.AppendChild(TypeCode);

    // Element ram:IssueDateTime
    IssueDateTime := Doc.CreateElement('ram:IssueDateTime');
    ExchangedDocument.AppendChild(IssueDateTime);

    // Element udt:DateTimeString
    DateTimeString := Doc.CreateElement('udt:DateTimeString');
    TDOMElement(DateTimeString).SetAttribute('format', '102');
    IssueDateTime.AppendChild(DateTimeString);

    Textelement := Doc.CreateTextNode('20241221');
    DateTimeString.Appendchild(Textelement);

    // Element ram:IncludedNote
    IncludedNote := Doc.CreateElement('ram:IncludedNote');
    ExchangedDocument.AppendChild(IncludedNote);

    // Element ram:Content
    Content := Doc.CreateElement('ram:Content');
    IncludedNote.AppendChild(Content);

    Textelement := Doc.CreateTextNode('Rechnung');
    IncludedNote.Appendchild(Textelement);

    // Element ram:SupplyChainTradeTransaction
    SupplyChainTradeTransaction := Doc.CreateElement('ram:SupplyChainTradeTransaction');
    CrossIndustryInvoice.AppendChild(SupplyChainTradeTransaction);

    // Element ram:IncludedSupplyChainTradeLineItem
    IncludedSupplyChainTradeLineItem := Doc.CreateElement('ram:IncludedSupplyChainTradeLineItem');
    SupplyChainTradeTransaction.AppendChild(IncludedSupplyChainTradeLineItem);


    // Element ram:AssociatedDocumentLineDocument
    AssociatedDocumentLineDocument := Doc.CreateElement('ram:AssociatedDocumentLineDocument');
    IncludedSupplyChainTradeLineItem.AppendChild(AssociatedDocumentLineDocument);

    // Element ram:LineID
    LineID := Doc.CreateElement('ram:LineID');
    AssociatedDocumentLineDocument.AppendChild(LineID);
    Textelement := Doc.CreateTextNode('1');
    LineID.Appendchild(Textelement);

    // Element ram:SpecifiedTradeProduct
    SpecifiedTradeProduct := Doc.CreateElement('ram:SpecifiedTradeProduct');
    IncludedSupplyChainTradeLineItem.AppendChild(SpecifiedTradeProduct);

    // Element ram:Name
    ram_Name := Doc.CreateElement('ram:Name');
    SpecifiedTradeProduct.AppendChild(ram_Name);
    Textelement := Doc.CreateTextNode('Usb Maus');
    ram_Name.Appendchild(Textelement);

    // Element ram:SpecifiedLineTradeAgreement
    SpecifiedLineTradeAgreement := Doc.CreateElement('ram:SpecifiedLineTradeAgreement');
    IncludedSupplyChainTradeLineItem.AppendChild(SpecifiedLineTradeAgreement);

    // Element ram:NetPriceProductTradePrice
    NetPriceProductTradePrice := Doc.CreateElement('ram:NetPriceProductTradePrice');
    SpecifiedLineTradeAgreement.AppendChild(NetPriceProductTradePrice);

    // Element ram:LineID
    ChargeAmount := Doc.CreateElement('ram:ChargeAmount');
    NetPriceProductTradePrice.AppendChild(ChargeAmount);
    Textelement := Doc.CreateTextNode('3.90');
    ChargeAmount.Appendchild(Textelement);


    writeXMLFile(Doc, 'test.xml');                           // schreibe in die XML-Datei
    Memo1.Lines.LoadFromFile('test.xml')
  finally
    Doc.Free;                                                // gib den Speicher frei
  end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  LExchangedDocumentNode, LIncludedSupplyChainTradeLineNode: IXmlNode;
  LIncludedSupplyChainTradeLineItemNode: array [0..9] of IXmlNode;
begin
  LExchangedDocumentNode := TXmlNode.New('rsm:ExchangedDocument')        // Rechnungskopf
        .AddElement('ram:ID', '1/KB/24')
        .AddElement('ram:TypeCode', '380')
        .AddNode(TXmlNode.New('ram:IssueDateTime')
          .AddElement('udt:DateTimeString', '20191030')
          .AddAttribute('format', '102'))
        .AddNode(TXmlNode.New('ram:IncludedNote')
        .AddElement('ram:Content', 'Rechnung'));


  LIncludedSupplyChainTradeLineItemNode[0] := TXmlNode.New('ram:IncludedSupplyChainTradeLineItem')
        .AddNode(TXmlNode.New('ram:IncludedSupplyChainTradeLineItem')
        .AddElement('ram:Content', 'Rechnung'));

  //LSupplyChainTradeTransactionNode.AddNode(LIncludedSupplyChainTradeLineItemNode[0]);
  LIncludedSupplyChainTradeLineNode := TXmlNode.New('ram:IncludedSupplyChainTradeLineItem')
    .AddNode(TXmlNode.New('ram:AssociatedDocumentLineDocument')
      .AddElement('ram:LineID', '1'))
    .AddNode(TXmlNode.New('ram:SpecifiedTradeProduct')
      .AddElement('ram:Name', 'Programm'))
    .AddNode(TXmlNode.New('ram:SpecifiedLineTradeAgreement')
      .AddNode(TXmlNode.New('ram:NetPriceProductTradePrice')
        .AddElement('ram:ChargeAmount', '1100.00')))
    .AddNode(TXmlNode.New('ram:SpecifiedLineTradeDelivery')
      .AddElement('ram:BilledQuantity', '1')
      .AddAttribute('unitCode', 'C62'))
;



  Memo1.Lines.Text:=TXmlBuilder.New
    .AddNode(TXmlNode.New('rsm:CrossIndustryInvoice')
      .AddAttribute('xmlns:rsm', 'urn:un:unece:uncefact:data:standard:CrossIndustryInvoice:100')
      .AddAttribute('xmlns:qdt', 'urn:un:unece:uncefact:data:standard:QualifiedDataType:100')
      .AddAttribute('xmlns:ram', 'urn:un:unece:uncefact:data:standard:ReusableAggregateBusinessInformationEntity:100')
      .AddAttribute('xmlns:xs', 'http://www.w3.org/2001/XMLSchema')
      .AddAttribute('xmlns:udt', 'urn:un:unece:uncefact:data:standard:UnqualifiedDataType:100')
      .AddNode(LExchangedDocumentNode)
      .AddNode(TXmlNode.New('rsm:SupplyChainTradeTransaction')
        .AddNode(LIncludedSupplyChainTradeLineNode)))
    .Xml;
  Memo1.Lines.SaveToFile('test1.xml');

end;

end.

